// NVPairParser.java - Abstract base class for name/value pair parsers.
//
// Copyright (C) 1999-2002  Smart Software Consulting
// 
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// 
// Smart Software Consulting
// 1688 Silverwood Court
// Danville, CA  94526-3079
// USA
// 
// http://www.smartsc.com
//

package com.smartsc.util;

import java.util.StringTokenizer;

public abstract class
NVPairParser
{
	public NVPairParser( String s, String pairSep, String nvSep)
	{
		this.s = s;
		this.pairSep = pairSep;
		this.nvSep = nvSep;
	}
	
	public void parse()
	{
		StringTokenizer nvPairs = new StringTokenizer( s, pairSep);
		while( nvPairs.hasMoreTokens())
		{
			String nvPair = (String)nvPairs.nextToken();
			StringTokenizer nv = new StringTokenizer( nvPair, nvSep);

			if( !nv.hasMoreTokens()) continue;
			String name = (String)nv.nextToken();
			String value = null;
			if( nv.hasMoreTokens())
			{
				value = (String)nv.nextToken();
				while( nv.hasMoreTokens())
				{
					value += pairSep + (String)nv.nextToken();
				}
			}
			forEachNVPair( name, value);
		}
	}
	
	public abstract void forEachNVPair( String name, String value);
	
	private String s;
	private String pairSep;
	private String nvSep;
}
	